package com.sos.scheduler.model.objects;

import java.util.ArrayList;
import java.util.List;

import org.apache.log4j.Logger;

import com.sos.VirtualFileSystem.Interfaces.ISOSVirtualFile;
import com.sos.scheduler.model.SchedulerObjectFactory;

/**
* \class JSObjSpooler 
* 
* \brief JSObjSpooler - 
* 
* \details
*
* \section JSObjSpooler.java_intro_sec Introduction
*
* \section JSObjSpooler.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author oh
* @version $Id$
* \see reference
*
* Created on 09.02.2011 15:21:07
 */

/**
 * @author oh
 *
 */
public class JSObjSpooler extends Spooler {

	private final String		conClassName	= "JSObjSpooler";
	@SuppressWarnings("unused")
	private static final Logger	logger			= Logger.getLogger(JSObjSpooler.class);

	public JSObjSpooler(final SchedulerObjectFactory schedulerObjectFactory) {
		super();
		objFactory = schedulerObjectFactory;
	}
	
	public JSObjSpooler(final SchedulerObjectFactory schedulerObjectFactory, final ISOSVirtualFile pobjVirtualFile) {
		super();
		objFactory = schedulerObjectFactory;
        final Spooler objSpooler = (Spooler) unMarshal(pobjVirtualFile);
        setObjectFieldsFrom(objSpooler);
        setHotFolderSrc(pobjVirtualFile);
        afterUnmarshal();
    }
	
	private void afterUnmarshal() {
        @SuppressWarnings("unused")
        final String conMethodName = conClassName + "::afterUnmarchal";
        Config objConfig = getConfig().get(0);
        if (objConfig.getSchedulerScript() != null) {
        	for (SchedulerScript objSchedulerScript : objConfig.getSchedulerScript()) {
        		if (objSchedulerScript.getScript() != null) {
                    removeEmptyContentsFrom(objSchedulerScript.getScript().getContent());
                }
            }
        }
        if (objConfig.getScript() != null) {
            removeEmptyContentsFrom(objConfig.getScript().getContent());
        }
    } // public afterUnmarchal
	
	/**
     * 
     * \brief removeEmptyContentsFrom
     * 
     * \details 
     * Some objects contain cdata as well as other objects, so that 
     * unmarshalling creates for every spaces around the other objects 
     * empty cdata nodes. These empty cdata nodes are removed.  
     *
     * \return void
     *
     * @param objList
     */
    private void removeEmptyContentsFrom(final List<Object> objList) {
        @SuppressWarnings("unused")
        final String conMethodName = conClassName + "::removeEmptyContentsFrom";
        final List<String> emptyContents = new ArrayList<String>();
        for (final Object listItem : objList) {
            if (listItem instanceof String && ((String) listItem).trim().length() == 0) {
                emptyContents.add(((String) listItem));
            }
        }
        objList.removeAll(emptyContents);
    } // private removeEmptyContentsFrom
}
